/*
 * stm32fxxx_hal.h
 *
 *  Created on: 13.06.2019
 *      Author: Rysiek
 */

/*
 * Plik naglwkowy na bazie pliku stm32fxxx_hal.h Tilena Majerle

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
#ifndef DEFINES_STM32FXXX_HAL_H_
#define DEFINES_STM32FXXX_HAL_H_

/* C++ detection */
#ifdef __cplusplus
extern "C" {
#endif

/* Include project config file */
#include "defines.h"

/* Defines for family used with libraries */
/* Uncomment line for your family used with HAL libraries */
//#define STM32F0xx /*!< Use STM32F0xx libraries */
//#define STM32F1xx /*!< Use STM32F1xx libraries */
//#define STM32F4xx /*!< Use STM32F4xx libraries */
//#define STM32F7xx /*!< Use STM32F7xx libraries */

/* Include proper header file */
/* STM32F0xx */
#if defined(STM32F0xx) || defined(STM32F0XX)
#ifndef STM32F0xx
#define STM32F0xx
#endif
#ifndef STM32F0XX
#define STM32F0XX
#endif
#include "stm32f0xx.h"
#include "stm32f0xx_hal.h"
#endif

/* STM32F1xx */
#if defined(STM32F1xx) || defined(STM32F1XX)
#ifndef STM32F1xx
#define STM32F1xx
#endif
#ifndef STM32F1XX
#define STM32F1XX
#endif
#include "stm32f1xx.h"
#include "stm32f1xx_hal.h"
#endif

/* STM32F4xx */
#if defined(STM32F4xx) || defined(STM32F4XX)
#ifndef STM32F4xx
#define STM32F4xx
#endif
#ifndef STM32F4XX
#define STM32F4XX
#endif
#include "stm32f4xx.h"
#include "stm32f4xx_hal.h"
#endif

/* STM32F7xx */
#if defined(STM32F7xx) || defined(STM32F7XX)
#ifndef STM32F7xx
#define STM32F7xx
#endif
#ifndef STM32F7XX
#define STM32F7XX
#endif
#include "stm32f7xx.h"
#include "stm32f7xx_hal.h"
#endif

/* C++ detection */
#ifdef __cplusplus
}
#endif


#endif /* DEFINES_STM32FXXX_HAL_H_ */
