/*
 * Wire.cpp
 *
 *  Created on: 03.06.2020
 *      Author: ryszard
 *      ARIES ars.info.pl
 */

/*
 * Biblioteka pośrednicząca pomiędzy kodem dla STM32 a biblioteką dla arduino Wire
 * v.0-01
 */

#include <PWire.h>
extern "C"{
	#include "Procedury_I2C_hard.h"
	#include "SSD1306_interfejs.h"
}
#include "string.h"


PWire::PWire() {
	// TODO Auto-generated constructor stub

}

PWire::~PWire() {
	// TODO Auto-generated destructor stub
}
//------------
//inicjacja korzystania z biblioteki Wire w trybie master
void PWire::begin()
{
	//nic nie robi
}
//------------
//odczytuje ilość (quantity) bajtów z układu podzędnego o adresie (address)
//zwraca ilość odebranych bajtów w buforze
uint8_t PWire::requestFrom(uint8_t address, uint8_t quantity)
{
	char stat=I2C_OdczytBloku((unsigned char)address,(unsigned char)MEM_ADRES_I2C_0BAJT,
			(unsigned char)reg_adress,(unsigned char)quantity,(char *)buforRec_Wire);
	if (stat ==FALSE) quantity = 0;
	ile_w_buforRec_Wire =quantity;
	poz_odczytu_w_buforRec_Wire =0;

	return quantity;
}
//-----------
//inicjacja transmisji do układu podrzędnego o adresie (address)
void PWire::beginTransmission(uint8_t adress)
{
	i2c_adress =adress;
	ile_w_buforWrite_Wire=0;
	statusWrite =WR_STAT_OK;
}
//-----------
//kończenie transmisji poprzez wysłanie zawartości buforu do układu podrzędnego
//zwraca status zapisu 0 (sukces), 1 (dane są zbyt długie, aby zmieścić się w buforze nadawczym)
//4 (inny bląd)
uint8_t PWire::endTransmission()
{
	//if (ile_w_buforWrite_Wire==0 || ile_w_buforWrite_Wire>ROZMIAR_BUF_WRITE) return 1;
	char stat =I2C_ZapisBloku((unsigned char)i2c_adress, (unsigned char)MEM_ADRES_I2C_0BAJT,
			(unsigned char)reg_adress, (unsigned char)ile_w_buforWrite_Wire, (char *)buforWrite_Wire);
	if (stat==FALSE) statusWrite=WR_STAT_ERR_TRANS;
	else if (statusWrite!=WR_STAT_ERR_DLUGOSC) statusWrite =WR_STAT_OK;
	return statusWrite;
}
//----------
//przygotowanie do wysłania pojedynczego bajtu (value)
//zwraca ilość bajtów do wysłania oczekujących w buforze
uint8_t PWire::write(uint8_t value)
{
	if (ile_w_buforWrite_Wire>=ROZMIAR_BUF_WRITE)
	{
		statusWrite =WR_STAT_ERR_DLUGOSC;
		return ile_w_buforWrite_Wire;
	}
	buforWrite_Wire[ile_w_buforWrite_Wire] =value;
	ile_w_buforWrite_Wire++;
	return ile_w_buforWrite_Wire;
}
//----------
//przygotowanie do wysłania stringu (string)
//zwraca ilość wysyłanych bajtów
uint8_t PWire::write(char *string)
{
	int ile =strlen(string);
	if ((ile+ile_w_buforWrite_Wire)>ROZMIAR_BUF_WRITE)
	{
		ile =ROZMIAR_BUF_WRITE;
		ile =ROZMIAR_BUF_WRITE-ile_w_buforWrite_Wire;
		statusWrite =WR_STAT_ERR_DLUGOSC;
	}else statusWrite =WR_STAT_OK;
	memcpy(&buforWrite_Wire[ile_w_buforWrite_Wire],string,ile);
	ile_w_buforWrite_Wire =ile_w_buforWrite_Wire+ile;
	return ile_w_buforWrite_Wire;
}
//----------
//przygotowanie do wysłania danych z buforu (data) w rozmiarze (length)
//zwraca ilość wysyłanych bajtów
uint8_t PWire::write(uint8_t *data, uint8_t length)
{
	int ile =length;
	if ((ile+ile_w_buforWrite_Wire)>ROZMIAR_BUF_WRITE)
	{
		ile =ROZMIAR_BUF_WRITE;
		ile =ROZMIAR_BUF_WRITE-ile_w_buforWrite_Wire;
		statusWrite =WR_STAT_ERR_DLUGOSC;
	}else statusWrite =WR_STAT_OK;
	memcpy(&buforWrite_Wire[ile_w_buforWrite_Wire],data,ile);
	ile_w_buforWrite_Wire =ile_w_buforWrite_Wire+ile;
	return ile_w_buforWrite_Wire;
}
//----------
//odczyt ilości odebranych danych w buforze
//zwraca ilość odebranych bajtów w buforze
uint8_t PWire::available()
{
	return ile_w_buforRec_Wire-poz_odczytu_w_buforRec_Wire;
}
//----------
//odczyt pojedynczego bajtu z buforu odbiorczego
//zwraca odczytany bajt
uint8_t PWire::read()
{
	uint8_t bajt =buforRec_Wire[poz_odczytu_w_buforRec_Wire];
	if (poz_odczytu_w_buforRec_Wire<ile_w_buforRec_Wire) poz_odczytu_w_buforRec_Wire++;
	return bajt;
}
