/*
 * PWire.h
 *
 *  Created on: 03.06.2020
 *      Author: ryszard
 */

#ifndef SRC_PROCEDURY_I2C_HARD_PWIRE_H_
#define SRC_PROCEDURY_I2C_HARD_PWIRE_H_

#include "defines.h"
#include "stm32fxxx_hal.h"

#define ROZMIAR_BUF_WRITE	32
#define ROZMIAR_BUF_READ	32
#define WR_STAT_OK			0
#define WR_STAT_ERR_DLUGOSC	1
#define WR_STAT_ERR_TRANS	4

class PWire {
public:
	PWire();
	virtual ~PWire();

	void begin();
	uint8_t requestFrom(uint8_t address, uint8_t quantity);
	void beginTransmission(uint8_t adress);
	uint8_t endTransmission();
	uint8_t write(uint8_t value);
	uint8_t write(char *string);
	uint8_t write(uint8_t *data, uint8_t length);
	uint8_t available();
	uint8_t read();
private:
	uint8_t reg_adress=0,i2c_adress=0;
	uint8_t buforRec_Wire[ROZMIAR_BUF_READ],ile_w_buforRec_Wire,poz_odczytu_w_buforRec_Wire=0;
	uint8_t buforWrite_Wire[ROZMIAR_BUF_WRITE], ile_w_buforWrite_Wire;
	uint8_t statusWrite=0;
};

#endif /* SRC_PROCEDURY_I2C_HARD_PWIRE_H_ */
