/*
 * Procedury_I2C_hard.c
 *
 *  Created on: 02.11.2019
 *      Author: Rysiek
 */

#include "Procedury_I2C_hard.h"

extern I2C_HandleTypeDef hi2c1;

//w main.c  I2C1 init function

//---------------------------------------------
//procedura odczytu bloku danych magistral I2C
char I2C_OdczytBloku(unsigned char slave_adr, unsigned char ile_bajtow_adresu,
		unsigned int adres_int, unsigned char ile_bajtow_danych, char *p_bufor)
//we: slave_adr 8 bitw
//wy: TRUE -sukces, FALSE -bd
{
HAL_StatusTypeDef status;

	if (ile_bajtow_adresu ==MEM_ADRES_I2C_0BAJT)
	{
		status =HAL_I2C_Master_Receive
		(&hi2c1, (uint16_t)slave_adr, (uint8_t *)p_bufor,
		(uint16_t)ile_bajtow_danych, 1000);
		if (status !=HAL_OK) return FALSE;
	}
	else if (ile_bajtow_adresu ==MEM_ADRES_I2C_1BAJT)
	{
		status =HAL_I2C_Mem_Read(&hi2c1,(uint16_t)slave_adr,(uint16_t)adres_int,I2C_MEMADD_SIZE_8BIT,
				(uint8_t *)p_bufor,(uint16_t)ile_bajtow_danych,1000);
		if (status !=HAL_OK) return FALSE;
	}
	else
	{
		if (ile_bajtow_adresu ==MEM_ADRES_I2C_2BAJTY)
		{
			status =HAL_I2C_Mem_Read(&hi2c1,(uint16_t)slave_adr,(uint16_t)adres_int,I2C_MEMADD_SIZE_16BIT,
					(uint8_t *)p_bufor,(uint16_t)ile_bajtow_danych,1000);
			if (status !=HAL_OK) return FALSE;
		}
		else return FALSE;//nie obsugiwany rozmiar adresu
	}

	return TRUE;
}
//--------------------------------------------
//procedura zapisu bloku danych magistral I2C
char I2C_ZapisBloku(unsigned char slave_adr, unsigned char ile_bajtow_adresu,
		unsigned int adres_int, unsigned char ile_bajtow_danych, char *p_bufor)
//we: slave_adr 8 bitw
{
HAL_StatusTypeDef status;

	if (ile_bajtow_adresu ==MEM_ADRES_I2C_0BAJT)
	{
		status =HAL_I2C_Master_Transmit
		(&hi2c1, (uint16_t)slave_adr, (uint8_t *)p_bufor,
		(uint16_t)ile_bajtow_danych, 1000);
		if (status !=HAL_OK) return FALSE;
	}
	else if (ile_bajtow_adresu ==MEM_ADRES_I2C_1BAJT)
	{
		status =HAL_I2C_Mem_Write(&hi2c1,(uint16_t)slave_adr,(uint16_t)adres_int,I2C_MEMADD_SIZE_8BIT,
				(uint8_t *)p_bufor,(uint16_t)ile_bajtow_danych,1000);
		if (status !=HAL_OK) return FALSE;
	}
	else
	{
		if (ile_bajtow_adresu ==MEM_ADRES_I2C_2BAJTY)
		{
			status =HAL_I2C_Mem_Write(&hi2c1,(uint16_t)slave_adr,(uint16_t)adres_int,I2C_MEMADD_SIZE_16BIT,
					(uint8_t *)p_bufor,(uint16_t)ile_bajtow_danych,1000);
			if (status !=HAL_OK) return FALSE;
		}
		else return FALSE;//nie obsugiwany rozmiar adresu
	}

	return TRUE;
}


