/*
 * SSD1306_procedury.h
 *
 * Procedury sterowania wywietlaczem 128x64 SSD1306
 * przystosowane do wsppracy z bibliotek Procedury_I2C_hard.c
 *  Created on: 1 czerwiec 2020
 *      Rysiek www.ars.info.pl
 */

#ifndef APPLICATION_SSD1306_PROCEDURY_H_
#define APPLICATION_SSD1306_PROCEDURY_H_

#include "defines.h"
#include "stm32fxxx_hal.h"

//SSD1306 adres slave wywietlacza
#define SSD1306_SLAVE_ADR		0x78

typedef enum{
	font_maly,
	font_sredni,
	font_duzy
}TFontRozmiar;

typedef enum{
	jasny,
	ciemny
}TKolor;

char SSD1306_Inicjacja(void);
char Write_Command(unsigned char Command);
char Write_Data(unsigned char Data);

void SSD1308_zetrzyj();
void SSD1306_GotoXY(uint16_t x, uint16_t y);
void SSD1306_UpdateScreen();
char SSD1306_Puts(char* str, TFontRozmiar font_rozmiar, TKolor kolor);

void fill_picture(unsigned char fill_Data);
void picture_XBM(const unsigned char *p_obrazek);
void picture_XBM_konwersja(unsigned char *p_buf_XBM_page, unsigned char *p_buf_konwersja_page);

#endif /* APPLICATION_SSD1306_PROCEDURY_H_ */
